Index: palm/trunk/SCRIPTS/mbuild
===================================================================
--- palm/trunk/SCRIPTS/mbuild	(revision 1825)
+++ palm/trunk/SCRIPTS/mbuild	(revision 1826)
@@ -22,5 +22,5 @@
 # Current revisions:
 # ------------------
-# 
+# Added note that the script does not work on MAC OS
 # 
 # Former revisions:
@@ -119,4 +119,6 @@
 # Procedure to compile code on local and remote hosts using the
 # make-mechanism. The source code must be provided on the local host.
+#
+# @note This script does not work on MAC OS
 #--------------------------------------------------------------------------------#
 
Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 1825)
+++ palm/trunk/SOURCE/Makefile	(revision 1826)
@@ -20,5 +20,6 @@
 # Current revisions:
 # ------------------
-#
+# Renamed radiation_model to radiation_model_mod.
+# Renamed plant_canopy_model to plant_canopy_model_mod.
 # 
 # Former revisions:
@@ -278,10 +279,10 @@
 	ls_forcing.f90 message.f90 microphysics.f90 modules.f90 mod_kinds.f90 \
 	mod_particle_attributes.f90 netcdf_interface.f90 nudging.f90 \
-	package_parin.f90 palm.f90 parin.f90 plant_canopy_model.f90 pmc_interface.f90 \
+	package_parin.f90 palm.f90 parin.f90 plant_canopy_model_mod.f90 pmc_interface.f90 \
 	pmc_client.f90 pmc_general.f90 pmc_handle_communicator.f90 pmc_mpi_wrapper.f90 \
 	pmc_server.f90 \
 	poisfft.f90 poismg.f90 \
 	poismg_fast.f90 pres.f90 print_1d.f90 production_e.f90 \
-	prognostic_equations.f90 progress_bar.f90 radiation_model.f90 \
+	prognostic_equations.f90 progress_bar.f90 radiation_model_mod.f90 \
 	random_function.f90 random_gauss.f90 random_generator_parallel.f90 \
 	read_3d_binary.f90 read_var_list.f90 run_control.f90 \
@@ -347,5 +348,5 @@
 advec_w_up.o: modules.o mod_kinds.o
 average_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
-                   radiation_model.o
+                   radiation_model_mod.o
 boundary_conds.o: modules.o mod_kinds.o
 buoyancy.o: modules.o mod_kinds.o
@@ -356,5 +357,5 @@
 check_open.o: modules.o mod_kinds.o mod_particle_attributes.o netcdf_interface.o
 check_parameters.o: modules.o mod_kinds.o land_surface_model_mod.o \
-	netcdf_interface.o plant_canopy_model.o pmc_interface.o radiation_model.o \
+	netcdf_interface.o plant_canopy_model_mod.o pmc_interface.o radiation_model_mod.o \
 	subsidence.o
 close_file.o: modules.o mod_kinds.o netcdf_interface.o
@@ -375,5 +376,5 @@
 data_output_tseries.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o
 data_output_2d.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o\
-   netcdf_interface.o land_surface_model_mod.o radiation_model.o
+   netcdf_interface.o land_surface_model_mod.o radiation_model_mod.o
 data_output_3d.o: modules.o cpulog.o mod_kinds.o mod_particle_attributes.o\
    netcdf_interface.o land_surface_model_mod.o
@@ -392,14 +393,14 @@
 fft_xy.o: cuda_fft_interfaces.o modules.o mod_kinds.o singleton.o temperton_fft.o
 flow_statistics.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
-   netcdf_interface.o radiation_model.o
+   netcdf_interface.o radiation_model_mod.o
 global_min_max.o: modules.o mod_kinds.o
 header.o: modules.o cpulog.o mod_kinds.o netcdf_interface.o land_surface_model_mod.o\
-   plant_canopy_model.o pmc_handle_communicator.o pmc_interface.o \
-   radiation_model.o spectrum.o subsidence.o 
+plant_canopy_model_mod.o pmc_handle_communicator.o pmc_interface.o \
+   radiation_model_mod.o spectrum.o subsidence.o
 inflow_turbulence.o: modules.o cpulog.o mod_kinds.o
 init_1d_model.o: modules.o mod_kinds.o
 init_3d_model.o: modules.o mod_kinds.o advec_ws.o cpulog.o land_surface_model_mod.o \
-   lpm_init.o ls_forcing.o netcdf_interface.o plant_canopy_model.o \
-   radiation_model.o random_function.o random_generator_parallel.o \
+   lpm_init.o ls_forcing.o netcdf_interface.o plant_canopy_model_mod.o \
+   radiation_model_mod.o random_function.o random_generator_parallel.o \
 	surface_layer_fluxes.o
 init_advec.o: modules.o mod_kinds.o
@@ -415,5 +416,5 @@
 init_slope.o: modules.o mod_kinds.o
 interaction_droplets_ptq.o: modules.o mod_kinds.o
-land_surface_model_mod.o: modules.o mod_kinds.o radiation_model.o
+land_surface_model_mod.o: modules.o mod_kinds.o radiation_model_mod.o
 local_stop.o: modules.o mod_kinds.o pmc_interface.o
 local_tremain.o: modules.o cpulog.o mod_kinds.o
@@ -454,11 +455,10 @@
    land_surface_model_mod.o spectrum.o
 nudging.o: modules.o cpulog.o mod_kinds.o
-package_parin.o: modules.o mod_kinds.o \
-   plant_canopy_model.o radiation_model.o spectrum.o
+package_parin.o: modules.o mod_kinds.o spectrum.o
 palm.o: modules.o cpulog.o ls_forcing.o mod_kinds.o nudging.o\
 	pmc_interface.o surface_layer_fluxes.o
 parin.o: modules.o cpulog.o land_surface_model_mod.o mod_kinds.o netcdf_interface.o \
-   pmc_interface.o progress_bar.o
-plant_canopy_model.o: modules.o mod_kinds.o
+   plant_canopy_model_mod.o pmc_interface.o progress_bar.o radiation_model_mod.o 
+plant_canopy_model_mod.o: modules.o mod_kinds.o
 pmc_interface.o: modules.o mod_kinds.o pmc_client.o pmc_general.o\
 	pmc_handle_communicator.o pmc_mpi_wrapper.o pmc_server.o
@@ -480,15 +480,15 @@
 	cpulog.o diffusion_e.o diffusion_s.o diffusion_u.o diffusion_v.o diffusion_w.o \
 	eqn_state_seawater.o mod_kinds.o microphysics.o \
-	nudging.o plant_canopy_model.o production_e.o radiation_model.o \
+	nudging.o plant_canopy_model_mod.o production_e.o radiation_model_mod.o \
 	subsidence.o user_actions.o
 progress_bar.o: modules.o mod_kinds.o
-radiation_model.o : modules.o mod_particle_attributes.o
+radiation_model_mod.o : modules.o mod_particle_attributes.o
 random_function.o: mod_kinds.o
 random_gauss.o: mod_kinds.o random_function.o random_generator_parallel.o
 random_generator_parallel.o: mod_kinds.o
 read_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
-                  radiation_model.o random_function.o\
+                  radiation_model_mod.o random_function.o\
                   random_generator_parallel.o
-read_var_list.o: modules.o mod_kinds.o netcdf_interface.o plant_canopy_model.o
+read_var_list.o: modules.o mod_kinds.o netcdf_interface.o plant_canopy_model_mod.o
 run_control.o: modules.o cpulog.o mod_kinds.o
 set_slicer_attributes_dvrp.o: modules.o mod_kinds.o
@@ -498,5 +498,5 @@
 subsidence.o: modules.o mod_kinds.o
 sum_up_3d_data.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
-                  radiation_model.o 
+                  radiation_model_mod.o 
 surface_coupler.o: modules.o cpulog.o mod_kinds.o
 surface_layer_fluxes.o: modules.o mod_kinds.o land_surface_model_mod.o
@@ -507,5 +507,5 @@
 	cpulog.o interaction_droplets_ptq.o land_surface_model_mod.o \
 	ls_forcing.o mod_kinds.o nudging.o pmc_interface.o production_e.o \
-	prognostic_equations.o progress_bar.o radiation_model.o \
+	prognostic_equations.o progress_bar.o radiation_model_mod.o \
 	spectrum.o user_actions.o surface_layer_fluxes.o
 time_to_string.o: mod_kinds.o
@@ -532,6 +532,6 @@
 user_init_grid.o: modules.o mod_kinds.o user_module.o
 user_init_land_surface.o: modules.o mod_kinds.o user_module.o land_surface_model_mod.o
-user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model.o
-user_init_radiation.o: modules.o mod_kinds.o user_module.o radiation_model.o
+user_init_plant_canopy.o: modules.o mod_kinds.o user_module.o plant_canopy_model_mod.o
+user_init_radiation.o: modules.o mod_kinds.o user_module.o radiation_model_mod.o
 user_last_actions.o: modules.o mod_kinds.o user_module.o
 user_lpm_advec.o: modules.o mod_kinds.o user_module.o
@@ -545,5 +545,5 @@
 wall_fluxes.o: modules.o mod_kinds.o
 write_3d_binary.o: modules.o cpulog.o mod_kinds.o land_surface_model_mod.o\
-                   radiation_model.o random_function.o\
+                   radiation_model_mod.o random_function.o\
                    random_generator_parallel.o
-write_var_list.o: modules.o mod_kinds.o netcdf_interface.o plant_canopy_model.o 
+write_var_list.o: modules.o mod_kinds.o netcdf_interface.o plant_canopy_model_mod.o 
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 1825)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 1826)
@@ -19,6 +19,8 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+! Moved checks for radiation model to the respective module.
+! Moved checks for plant canopy model to the respective module.
+! Bugfix for check of too large roughness_length
+!
 ! Former revisions:
 ! -----------------
@@ -349,5 +351,6 @@
     USE land_surface_model_mod,                                                &
         ONLY: land_surface, lsm_check_data_output, lsm_check_data_output_pr,   &
-              lsm_check_parameters, nzs, zs
+              lsm_check_parameters
+
     USE kinds
     USE model_1d
@@ -355,11 +358,17 @@
         ONLY:  dopr_unit, do2d_unit, do3d_unit, netcdf_data_format,            &
                netcdf_data_format_string
+
     USE particle_attributes
     USE pegrid
-    USE plant_canopy_model_mod
+    USE plant_canopy_model_mod,                                                &
+        ONLY:  pcm_check_parameters, plant_canopy
+        
     USE pmc_interface,                                                         &
         ONLY:  cpl_id, nested_run
+
     USE profil_parameter
-    USE radiation_model_mod
+    USE radiation_model_mod,                                                   &
+        ONLY: radiation, radiation_check_data_output,                          &
+              radiation_check_data_output_pr, radiation_check_parameters
     USE statistics
     USE subsidence_mod
@@ -1022,97 +1031,15 @@
     ENDIF
 
-    IF ( plant_canopy )  THEN
+!
+!-- When plant canopy model is used, peform addtional checks
+    IF ( plant_canopy )  CALL pcm_check_parameters
     
-       IF ( canopy_drag_coeff == 0.0_wp )  THEN
-          message_string = 'plant_canopy = .TRUE. requires a non-zero drag '// &
-                           'coefficient & given value is canopy_drag_coeff = 0.0'
-          CALL message( 'check_parameters', 'PA0041', 1, 2, 0, 6, 0 )
-       ENDIF
-    
-       IF ( ( alpha_lad /= 9999999.9_wp  .AND.  beta_lad == 9999999.9_wp )  .OR.&
-              beta_lad /= 9999999.9_wp   .AND.  alpha_lad == 9999999.9_wp )  THEN
-          message_string = 'using the beta function for the construction ' //  &
-                           'of the leaf area density profile requires '    //  &
-                           'both alpha_lad and beta_lad to be /= 9999999.9'
-          CALL message( 'check_parameters', 'PA0118', 1, 2, 0, 6, 0 )
-       ENDIF
-    
-       IF ( calc_beta_lad_profile  .AND.  lai_beta == 0.0_wp )  THEN
-          message_string = 'using the beta function for the construction ' //  &
-                           'of the leaf area density profile requires '    //  &
-                           'a non-zero lai_beta, but given value is '      //  &
-                           'lai_beta = 0.0'
-          CALL message( 'check_parameters', 'PA0119', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       IF ( calc_beta_lad_profile  .AND.  lad_surface /= 0.0_wp )  THEN
-          message_string = 'simultaneous setting of alpha_lad /= 9999999.9' // &
-                           'and lad_surface /= 0.0 is not possible, '       // &
-                           'use either vertical gradients or the beta '     // &
-                           'function for the construction of the leaf area '// &
-                           'density profile'
-          CALL message( 'check_parameters', 'PA0120', 1, 2, 0, 6, 0 )
-       ENDIF 
-
-       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-          message_string = 'plant_canopy = .TRUE. requires cloud_scheme /=' // &
-                           ' seifert_beheng'
-          CALL message( 'check_parameters', 'PA0360', 1, 2, 0, 6, 0 )
-       ENDIF 
-
-    ENDIF
-
 !
 !-- When land surface model is used, peform addtional checks
     IF ( land_surface )  CALL lsm_check_parameters
 
-
-    IF ( radiation )  THEN
-       IF ( radiation_scheme /= 'constant'   .AND.                             &
-            radiation_scheme /= 'clear-sky'  .AND.                             &
-            radiation_scheme /= 'rrtmg' )  THEN
-          message_string = 'unknown radiation_scheme = '//                     &
-                           TRIM( radiation_scheme )
-          CALL message( 'check_parameters', 'PA0405', 1, 2, 0, 6, 0 )
-       ELSEIF ( radiation_scheme == 'rrtmg' )  THEN
-#if ! defined ( __rrtmg )
-          message_string = 'radiation_scheme = "rrtmg" requires ' //           & 
-                           'compilation of PALM with pre-processor ' //        &
-                           'directive -D__rrtmg'
-          CALL message( 'check_parameters', 'PA0407', 1, 2, 0, 6, 0 )
-#endif
-#if defined ( __rrtmg ) && ! defined( __netcdf )
-          message_string = 'radiation_scheme = "rrtmg" requires ' //           & 
-                           'the use of NetCDF (preprocessor directive ' //     &
-                           '-D__netcdf'
-          CALL message( 'check_parameters', 'PA0412', 1, 2, 0, 6, 0 )
-#endif
-
-       ENDIF
-       IF ( albedo_type == 0  .AND.  albedo == 9999999.9_wp  .AND.             &
-            radiation_scheme == 'clear-sky')  THEN
-          message_string = 'radiation_scheme = "clear-sky" in combination' //  & 
-                           'with albedo_type = 0 requires setting of albedo'// &
-                           ' /= 9999999.9'
-          CALL message( 'check_parameters', 'PA0410', 1, 2, 0, 6, 0 )
-       ENDIF
-       IF ( albedo_type == 0  .AND.  radiation_scheme == 'rrtmg'  .AND.        &
-          (    albedo_lw_dif == 9999999.9_wp .OR. albedo_lw_dir == 9999999.9_wp&
-          .OR. albedo_sw_dif == 9999999.9_wp .OR. albedo_sw_dir == 9999999.9_wp& 
-          ) ) THEN
-          message_string = 'radiation_scheme = "rrtmg" in combination' //      & 
-                           'with albedo_type = 0 requires setting of ' //      &
-                           'albedo_lw_dif /= 9999999.9' //                     &
-                           'albedo_lw_dir /= 9999999.9' //                     &
-                           'albedo_sw_dif /= 9999999.9 and' //                 &
-                           'albedo_sw_dir /= 9999999.9'
-          CALL message( 'check_parameters', 'PA0411', 1, 2, 0, 6, 0 )
-       ENDIF
-       IF ( topography /= 'flat' )  THEN
-          message_string = 'radiation scheme cannot be used ' //               & 
-                           'in combination with  topography /= "flat"'
-          CALL message( 'check_parameters', 'PA0414', 1, 2, 0, 6, 0 )
-       ENDIF
-    ENDIF
+!
+!-- When radiation model is used, peform addtional checks
+    IF ( radiation )  CALL radiation_check_parameters
 
     IF ( .NOT. ( loop_optimization == 'cache'  .OR.                            &
@@ -2980,134 +2907,16 @@
              ENDIF
 
-          CASE ( 'rad_net' )
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme == 'constant' )&
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme = "constant"'
-                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 101
-                dopr_unit(i)  = 'W/m2'
-                hom(:,2,101,:)  = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_lw_in' )
-             IF ( (  .NOT.  radiation)  .OR.  radiation_scheme == 'constant' ) &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme = "constant"'
-                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 102
-                dopr_unit(i)  = 'W/m2'
-                hom(:,2,102,:)  = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_lw_out' )
-             IF ( (  .NOT. radiation )  .OR.  radiation_scheme == 'constant' ) &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme = "constant"'
-                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 103
-                dopr_unit(i)  = 'W/m2'
-                hom(:,2,103,:)  = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_sw_in' )
-             IF ( (  .NOT. radiation )  .OR.  radiation_scheme == 'constant' ) &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme = "constant"'
-                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 104
-                dopr_unit(i)  = 'W/m2'
-                hom(:,2,104,:)  = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_sw_out')
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme == 'constant' ) &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme = "constant"'
-                CALL message( 'check_parameters', 'PA0408', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 105
-                dopr_unit(i)  = 'W/m2'
-                hom(:,2,105,:)  = SPREAD( zw, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_lw_cs_hr' )
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme /= 'rrtmg' )   &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme /= "rrtmg"'
-                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 106
-                dopr_unit(i)  = 'K/h'
-                hom(:,2,106,:)  = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_lw_hr' )
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme /= 'rrtmg' )   &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme /= "rrtmg"'
-                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 107
-                dopr_unit(i)  = 'K/h'
-                hom(:,2,107,:)  = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_sw_cs_hr' )
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme /= 'rrtmg' )   &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme /= "rrtmg"'
-                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 108
-                dopr_unit(i)  = 'K/h'
-                hom(:,2,108,:)  = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
-
-          CASE ( 'rad_sw_hr' )
-             IF ( (  .NOT.  radiation )  .OR.  radiation_scheme /= 'rrtmg' )   &
-             THEN
-                message_string = 'data_output_pr = ' //                        &
-                                 TRIM( data_output_pr(i) ) // ' is not ava' // &
-                                 'lable for radiation = .FALSE. or ' //        &
-                                 'radiation_scheme /= "rrtmg"'
-                CALL message( 'check_parameters', 'PA0413', 1, 2, 0, 6, 0 )
-             ELSE
-                dopr_index(i) = 109
-                dopr_unit(i)  = 'K/h'
-                hom(:,2,109,:)  = SPREAD( zu, 2, statistic_regions+1 )
-             ENDIF
+ 
 
           CASE DEFAULT
 
-             CALL lsm_check_data_output_pr( data_output_pr(i), i, unit, dopr_unit(i) )
-
+             CALL lsm_check_data_output_pr( data_output_pr(i), i, unit,        &
+                                            dopr_unit(i) )
+
+             IF ( unit == 'illegal' )  THEN
+                CALL radiation_check_data_output_pr( data_output_pr(i), i,     &
+                                                     unit, dopr_unit(i) )
+             ENDIF
+             
              IF ( unit == 'illegal' )  THEN
                 CALL user_check_data_output_pr( data_output_pr(i), i, unit )
@@ -3288,14 +3097,4 @@
              unit = 'kg/kg'
 
-          CASE ( 'rad_lw_in', 'rad_lw_out', 'rad_lw_cs_hr', 'rad_lw_hr',       &
-                 'rad_sw_in', 'rad_sw_out', 'rad_sw_cs_hr', 'rad_sw_hr' )
-             IF (  .NOT.  radiation  .OR.  radiation_scheme /= 'rrtmg' )  THEN
-                message_string = '"output of "' // TRIM( var ) // '" requi' // &
-                                 'res radiation = .TRUE. and ' //              &
-                                 'radiation_scheme = "rrtmg"'
-                CALL message( 'check_parameters', 'PA0406', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'W/m2'
-
           CASE ( 'rho' )
              IF (  .NOT.  ocean )  THEN
@@ -3330,7 +3129,6 @@
              CONTINUE
 
-          CASE ( 'lai*', 'lwp*', 'ol*', 'pra*', 'prr*', 'qsws*', 'rad_net*',   &
-                 'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*', 'rrtm_asdir*',   &
-                 'shf*', 't*', 'u*', 'z0*', 'z0h*', 'z0q*' )
+          CASE ( 'lai*', 'lwp*', 'ol*', 'pra*', 'prr*', 'qsws*', 'shf*', 't*', &
+                 'u*', 'z0*', 'z0h*', 'z0q*' )
              IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
                 message_string = 'illegal value for data_output: "' //         &
@@ -3339,21 +3137,5 @@
                 CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
              ENDIF
-             IF (  .NOT.  radiation  .OR.  radiation_scheme /= "rrtmg" )  THEN
-                IF ( TRIM( var ) == 'rrtm_aldif*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_aldir*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_asdif*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_asdir*'      )                       &
-                THEN
-                   message_string = 'output of "' // TRIM( var ) // '" require'&
-                                    // 's radiation = .TRUE. and radiation_sch'&
-                                    // 'eme = "rrtmg"'
-                   CALL message( 'check_parameters', 'PA0409', 1, 2, 0, 6, 0 )
-                ENDIF
-             ENDIF
-             IF ( TRIM( var ) == 'lai*'  .AND.  .NOT.  land_surface )  THEN
-                message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res land_surface = .TRUE.'
-                CALL message( 'check_parameters', 'PA0404', 1, 2, 0, 6, 0 )
-             ENDIF
+
              IF ( TRIM( var ) == 'lwp*'  .AND.  .NOT. cloud_physics )  THEN
                 message_string = 'output of "' // TRIM( var ) // '" requi' //  &
@@ -3384,5 +3166,4 @@
              ENDIF
 
-             IF ( TRIM( var ) == 'lai*'   )  unit = 'none'
              IF ( TRIM( var ) == 'lwp*'   )  unit = 'kg/m2'
              IF ( TRIM( var ) == 'ol*'   )   unit = 'm'
@@ -3390,9 +3171,4 @@
              IF ( TRIM( var ) == 'prr*'   )  unit = 'mm/s'
              IF ( TRIM( var ) == 'qsws*'  )  unit = 'kgm/kgs'
-             IF ( TRIM( var ) == 'rad_net*'      ) unit = 'W/m2'   
-             IF ( TRIM( var ) == 'rrtm_aldif*'   ) unit = ''   
-             IF ( TRIM( var ) == 'rrtm_aldir*'   ) unit = '' 
-             IF ( TRIM( var ) == 'rrtm_asdif*'   ) unit = '' 
-             IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = '' 
              IF ( TRIM( var ) == 'shf*'   )  unit = 'K*m/s'
              IF ( TRIM( var ) == 't*'     )  unit = 'K'
@@ -3404,5 +3180,9 @@
 
              CALL lsm_check_data_output ( var, unit, i, ilen, k )
-             
+ 
+             IF ( unit == 'illegal' )  THEN
+                CALL radiation_check_data_output( var, unit, i, ilen, k )
+             ENDIF
+
              IF ( unit == 'illegal' )  THEN
                 CALL user_check_data_output( var, unit )
@@ -4073,4 +3853,6 @@
     ENDIF
 
+    CALL location_message( 'finished', .TRUE. )
+
 !
 !-- Prevent empty time records in volume, cross-section and masked data in case of 
@@ -4100,5 +3882,5 @@
     IF ( ( constant_flux_layer .OR.  &
            INDEX( initializing_actions, 'set_1d-model_profiles' ) /= 0 ) &
-         .AND. roughness_length <= 0.5 * dz )  THEN
+         .AND. roughness_length > 0.5 * dz )  THEN
        message_string = 'roughness_length must be smaller than dz/2'
        CALL message( 'check_parameters', 'PA0424', 1, 2, 0, 6, 0 )
